unit uSendIRcode;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TfrmSendIRCode = class(TForm)
    cbIRProtocol: TComboBox;
    Label1: TLabel;
    edIRProtocol: TEdit;
    edAddress: TEdit;
    Label2: TLabel;
    Label3: TLabel;
    edCommand: TEdit;
    Label4: TLabel;
    edFlags: TEdit;
    btSend: TButton;
    btClose: TButton;
    procedure OnChange(Sender: TObject);
    procedure OnKeyPress(Sender: TObject; var Key: Char);
    procedure btCloseClick(Sender: TObject);
    procedure btSendClick(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  frmSendIRCode: TfrmSendIRCode;

implementation

{$R *.dfm}

uses
  uMain;

procedure TfrmSendIRCode.btCloseClick(Sender: TObject);
begin
  Close;
end;

procedure TfrmSendIRCode.btSendClick(Sender: TObject);
begin
  uMain.IRReport.Data.Protocol := StrToIntDef(edIrProtocol.Text, 0);
  uMain.IRReport.Data.Address := StrToIntDef('$0' + edAddress.Text, 0);
  uMain.IRReport.Data.Command := StrToIntDef('$0' + edCommand.Text, 0);
  uMain.IRReport.Data.Flags := StrToIntDef('$0' + edFlags.Text, 0);

  Close;
end;

procedure TfrmSendIRCode.OnChange(Sender: TObject);
begin
  if cbIRProtocol.ItemIndex > -1 then
    edIrProtocol.Text :=
      IntToStr(uMain.IRMP_PROTOCOLS[cbIRProtocol.ItemIndex].Protocol);
end;

procedure TfrmSendIRCode.OnKeyPress(Sender: TObject; var Key: Char);
begin
  if not (Key in [#8, '0'..'9', 'A'..'F', 'a'..'f']) then
    Key := #0;

  if Sender = edAddress then
  begin
    if (Length(edAddress.Text) >= 4) and (Key <> #8) then
      Key :=#0;
  end
  else
  if Sender = edCommand then
  begin
    if (Length(edCommand.Text) >= 4) and (Key <> #8) then
      Key :=#0;
  end
  else
  if Sender = edFlags then
  begin
    if (Length(edFlags.Text) >= 2) and (Key <> #8) then
      Key :=#0;
  end;
end;

end.
